/*
 File : working_camera_pan_and_tilt_V3.ino
 
 BEST WORKING!!!
 
 Both panning and Tiliting of a camera
 Using Steppers Motors and not servos
 
 Sketch is under devepoment and I would clase as buggy.
 Sketch will most likely need changing to suit
 your camera, etc..
 
 Arduino Camera Tilt using the 28BYJ-48 stepper
 board purchased off eBay. 
 These a common on eBay.
 
 A video about this, on YouTube
 
 Arduino Steppers Pan and Tilt V2. Mainly hardware improvements
 http://youtu.be/I-yErUCsaeQ
 
 Arduino Testing 28BYJ-48 Stepper Motor Strength & Power
 http://youtu.be/8q5-kOTL69U
 
 
 Set for 28BYJ-48 stepper
 NOTE: because I basically plug this in upside
 down the sketch make the motor turn the other
 way, this can be changed in this sketch.
 
 28BYJ-48 stepper with acelstepper library
 it is set to accelerate from stating and
 deceleration near the stopping. This is to
 reduce sudden starts or stops
 
 The AccelStepper library for Arduino 
 http://www.airspayce.com/mikem/arduino/AccelStepper/index.html
 
 The control board uses the ULN2003 Darlington Array.
 
 YouTube video about  Test a stepper controller
 http://youtu.be/ec9k214ziw0
 
 
 This sketch modified from:-
 
 accellsteppertest.ino
 
 Runs one stepper forwards and backwards, accelerating and decelerating
 at the limits. Derived from example code by Mike McCauley
 Set for 28BYJ-48 stepper
 
 Video: accelstepper 28BYJ-48 demo 
 http://youtu.be/1F3240hCHE4
 
 An Arduino driven demo of 28BYJ-48 stepper with acelstepper library
 showing acceleration and deceleration. The stepper goes one
 revolution slowing to a stop before reversing, 
 with acceleration and deceleration. 
 The sketch can be obtained from:
 
 Sketch accellsteppertest.ino
 accellstepper 28BYJ-48
 http://pastebin.com/70QZmCj5
 
 
 Arduino Experiments YouTube Playlist about the $9.00 Arduino.
 http://www.youtube.com/playlist?list=PL1N3_q4khW7LvjfbQBRtrvbMknXwYzRae
 
 Microcontrollers, Controllers
 http://www.acomputerportal.com/microcontrollers_controllers.html
 
 Computers, Robots and Electronics, etc...
 http://www.acomputerportal.com
 
 
 5v 28YBJ-48 Stepper Motor with Gear Reduction,
 so it has good torque for its size, but relatively slow motion. 
 These motors/drivers are made by the millions for A/C units,
 fans, duct controls etc. which is why they are so inexpensive.
 
 4 Phase 5 Wire Connection
 •	100% Brand New
 •	Phase : 4
 •	Current : 92mA
 •	Resistance : 130 Ω
 •	Voltage : 5V DC
 •	Step Angle (Internal Motor alone): 5.625° (64 steps per revolution)
 •	Step angle: 5.625 x 1/64 at Output Shaft
 •	Gear Reduction ratio: 1 / 64
 •	SO: it should take 4096 steps per output shaft revolution.. To Be Proved.
 •	No-Load Pull-Out Frequency : 800pps
 •	No-Load Pull-In Frequency : 500pps
 •	Pull-In Torque : ≥ 78.4mN.m
 •	Wiring Instruction : A (Blue), B (Pink), C (Yellow), D (Orange), E (Red, Mid-Poconst int)
 •	Weight : 30g

Unipolar Stepper Motor 28-BYJ48

Rated voltage ： 5VDC

Number of Phase ： 4

Speed Variation Ratio ： 1/64

Stride Angle ： 5.625° /64

Frequency : 100Hz

DC resistance ： 50Ω±7%(25℃)

Idle In-traction Frequency : > 600Hz

Idle Out-traction Frequency : > 1000Hz

In-traction Torque  >34.3mN.m(120Hz)

Self-positioning Torque >34.3mN.m

Friction torque : 600-1200 gf.cm

Pull in torque : 300 gf.cm

Insulated resistance >10MΩ(500V)

Insulated electricity power ：600VAC/1mA/1s

Insulation grade ：A

Rise in Temperature  <40K(120Hz)

Noise  <35dB(120Hz,No load,10cm)
 
Model ： 28BYJ-48
You must take something  in consider :

This Motor has a Gear ratio of 64 , and Stride Angle 5.625°  so this motor has a 4096 Steps .

 steps = Number of steps in One Revolution  * Gear ratio   .

 steps= (360°/5.625°)*64"Gear ratio" = 64 * 64 =4096 . this value will substitute it on The arduino Sketch 

 */


// The AccelStepper library for Arduino 
// http://www.airspayce.com/mikem/arduino/AccelStepper/index.html


// http://www.airspayce.com/mikem/arduino/AccelStepper/classAccelStepper.html#a748665c3962e66fbc0e9373eb14c69c1

/*
Circuit
 
 Input
 
 The X Motor Two buttons Pan Left or Right if button is pressed
 buttonPinPanCameraLeft=  A0   // Green and white
 buttonPinPanCameraRight= A1   // White and blue
 The Y Motor Two buttons Tilt Up or Down if button is pressed
 buttonPinTiltCameraUp=   A2  // White and orange
 buttonPinTiltCameraDown= A3  // Orange and white
 
 SwitchForFasterSpeedPin= A5 // White and green
 
 Blue and whit to GRN, Ground
 
 Output to  Darlington array then onto 28BYJ48 Motors
 
 X motor drive pins
 Arduino Pin 2 Blue wire to   Darlington array motorXPin1 = 2	// Blue wire on 28BYJ48 Motor pin 1 
 Arduino Pin 3 Green wire to  Darlington array motorXPin2 = 3	// Pink wire on 28BYJ48 Motor pin 2
 Arduino Pin 4 Yellow wire to Darlington array motorXPin3 = 4	// Yellow wire on 28BYJ48 Motor pin 3
 Arduino Pin 5 Red wire to    Darlington array motorXPin4 = 5	// Orange wire on 28BYJ48 Motor pin 4
 Red    - 28BYJ48 pin 5 (VCC)
 
 Y motor drive pins
 Arduino Pin 6 Blue wire to   Darlington array motorYPin5 = 6	// Blue wire on 28BYJ48 Motor pin 1 
 Arduino Pin 7 Green wire to  Darlington array motorYPin6 = 7	// Pink wire on 28BYJ48 Motor pin 2
 Arduino Pin 8 Yellow wire to Darlington array motorYPin7 = 8	// Yellow wire on 28BYJ48 Motor pin 3
 Arduino Pin 9 Red wire to    Darlington array motorYPin8 = 9	// Orange wire on 28BYJ48 Motor pin 4
 Red    - 28BYJ48 pin 5 (VCC)
 
 The two  Red    - 28BYJ48 pin 5 (VCC) are linked together
 They are connected to the Positive of the Darlington array and otothe Ardunio Positive
 
 The Negative are connected to the Negative of the Darlington array and to the Ardunio Negative
 
 The Positive and Negative are connected to 5V
 
 */

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

#include <AccelStepper.h>

#define FULLSTEP 4
#define HALFSTEP 8

// Positive Clockwise looking towards the shaft
// Negative Anticlockwise looking towards the shaft
// There appears to be a limit on this value
// I have only tried it upto 5 and -5
// NOTE: because I basically plug this in upside
// down the sketch make the motor turn the other
// way, this can be changed in this sketch.

// Declare variables for the X motor pins
const int motorXPin1 = 2;	// Blue   - 28BYJ48 pin 1
const int motorXPin2 = 3;	// Pink   - 28BYJ48 pin 2
const int motorXPin3 = 4;	// Yellow - 28BYJ48 pin 3
const int motorXPin4 = 5;	// Orange - 28BYJ48 pin 4
// Red    - 28BYJ48 pin 5 (VCC)

// The X Motor sequence 4-2-3-1 required for proper sequencing of 28BYJ48
AccelStepper stepper1(FULLSTEP, motorXPin4, motorXPin2, motorXPin3, motorXPin1);

// The X Motor Two buttons Pan Left or Right if button is pressed

const int buttonPinPanCameraLeft=  A0;
const int buttonPinPanCameraRight= A1;

// The X Motor Two buttons Pan Up or Down if button is pressed
// High = Off not pressed
boolean buttonPinPanCameraLeftVal;
boolean buttonPinPanCameraRightVal;

// X Starting stepper postition
int cameraXPosition=0;

// X limits stepper postition. Prevent going any futher than this
const int maximumCameraRightPosition = 1000;
const int maximumCameraLeftPosition =  -1000;

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

// Declare variables for the Y motor pins
const int motorYPin5 = 6;	// Blue   - 28BYJ48 pin 1
const int motorYPin6 = 7;	// Pink   - 28BYJ48 pin 2
const int motorYPin7 = 8;	// Yellow - 28BYJ48 pin 3
const int motorYPin8 = 9;	// Orange - 28BYJ48 pin 4
// Red    - 28BYJ48 pin 5 (VCC)

// The Y Motor sequence 8-6-7-5 required for proper sequencing of 28BYJ48
AccelStepper stepper2(FULLSTEP, motorYPin8, motorYPin6, motorYPin7, motorYPin5);

// The Y Motor Two buttons Tilt Up or Down if button is pressed
const int buttonPinTiltCameraUp=   A2;
const int buttonPinTiltCameraDown= A3;

// High = Off not pressed
boolean buttonPinTiltCameraUpVal;
boolean buttonPinTiltCameraDownVal;

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

// Y Starting stepper postition
int cameraYPosition=0;

// Y limits stepper postition. Prevent going any futher than this
const int maximumCameraUpPosition=1000;
const int maximumCameraDownPosition=-1000;

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

// Movement speed, faster if pressed
const int buttonPinFasterSpeed=A4;

boolean buttonPinFasterSpeedVal;

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////


void setup()
{
  // X Buttons set to input

  //  Buttons Input and turn on internal pull-up resistor.
  pinMode(buttonPinPanCameraLeft, INPUT_PULLUP); 
  pinMode(buttonPinPanCameraRight, INPUT_PULLUP); 

  // The desired maximum speed in steps per second.
  // Must be > 0. Caution: Speeds that exceed the
  // maximum speed supported by the processor
  // may Result in non-linear accelerations and decelerations. 
  stepper1.setMaxSpeed(1000.0);

  // Higher value=shorter 
  // The desired acceleration in steps per second per second.
  // Must be > 0.0. This is an expensive call since it
  // requires a square root to be calculated.
  // Dont call more often than needed
  // 100 = No acceleration
  // Note Any deacceleration will cause a run on after while
  // the deacceleration takes place
  stepper1.setAcceleration(50.0);

  // The desired constant speed in steps per second.
  // Positive is clockwise. Speeds of more than
  // 1000 steps per second are unreliable.
  // Very slow speeds may be set
  // (eg 0.00027777 for once per hour, approximately.
  // Speed accuracy depends on the Arduino crystal.
  // Jitter depends on how frequently you call the
  // RunSpeed() function. 
  stepper1.setSpeed(200);

  ///   stepper1.setcameraXPosition 	( 0 ) 	;


  // Y Buttons set to input

  //  Buttons Input and turn on internal pull-up resistor.
  pinMode(buttonPinTiltCameraUp, INPUT_PULLUP); 
  pinMode(buttonPinTiltCameraDown, INPUT_PULLUP); 

  // The desired maximum speed in steps per second.
  // Must be > 0. Caution: Speeds that exceed the
  // maximum speed supported by the processor
  // may Result in non-linear accelerations and decelerations. 
  stepper2.setMaxSpeed(1000.0);

  // Higher value=shorter 
  // The desired acceleration in steps per second per second.
  // Must be > 0.0. This is an expensive call since it
  // requires a square root to be calculated.
  // Dont call more often than needed
  // 100 = No acceleration
  // Note Any deacceleration will cause a run on after while
  // the deacceleration takes place
  stepper2.setAcceleration(50.0);

  // The desired constant speed in steps per second.
  // Positive is clockwise. Speeds of more than
  // 1000 steps per second are unreliable.
  // Very slow speeds may be set
  // (eg 0.00027777 for once per hour, approximately.
  // Speed accuracy depends on the Arduino crystal.
  // Jitter depends on how frequently you call the
  // RunSpeed() function. 
  stepper2.setSpeed(200);

  ///   stepper2.setcameraYPosition 	( 0 ) 	;

  /////////////////////////////////////////////////////////////

  // Movement speed, faster if pressed

  //  Buttons Input and turn on internal pull-up resistor.
  pinMode(buttonPinFasterSpeed, INPUT_PULLUP); 

  // Serial display output if required e.g. debugging, etc...
  // Serial.begin(9600); // Standard is 9600
}


/////////////////////////////////////////
////////////////////////////////////////

void loop()  {
  // buttonVal is equal to HIGH if the switch is
  // not connected, i.e. off,
  // and LOW if the switch is preesed connected

  buttonPinPanCameraLeftVal  =  digitalRead(buttonPinPanCameraLeft);
  buttonPinPanCameraRightVal =  digitalRead(buttonPinPanCameraRight);

  //   cameraXPosition=  stepper1.currentPosition();


  // delay (5);
    
  buttonPinTiltCameraUpVal   =  digitalRead(buttonPinTiltCameraUp);
  buttonPinTiltCameraDownVal =  digitalRead(buttonPinTiltCameraDown);  

  //   cameraYPosition=  stepper2.currentPosition();

  // delay (5);
    
    
    
  //   Movement speed, faster if pressed  reset to button not pressed
  buttonPinFasterSpeedVal   =  digitalRead(buttonPinFasterSpeed);  


  // X Pan left or Right Calculate

  // X Pan left Calculate
  // No more panning camera left than this
  if((buttonPinPanCameraLeftVal==LOW) && (buttonPinPanCameraRightVal==HIGH) && (cameraXPosition > maximumCameraLeftPosition))     {

    cameraXPosition--;

//    Serial.print("[Pan Left pressed] X Pan Calculate cameraXPosition\t=");
//    Serial.print(cameraXPosition);
//    Serial.print("\tDown Up cameraYPosition\t=");
//    Serial.print(cameraYPosition);
  }   // Pan Left Calculate

  // X Pan Right Calculate
  // No more panning camera right than this
  if((buttonPinPanCameraRightVal==LOW) && (buttonPinPanCameraLeftVal==HIGH) && (cameraXPosition < maximumCameraRightPosition))     {

    cameraXPosition++;

//    Serial.print("[Pan Right pressed] X Calculate cameraXPosition\t=");
//    Serial.print(cameraXPosition);
//    Serial.print("\tDown Up cameraYPosition\t=");
//    Serial.print(cameraYPosition);
  }   // X Pan Right Calculate

////////////////////////////////////////////////////////////////////////

  // Y Tilt Up and Down Calculate

  // Y Tilt Up Calculate
  // No more tilting camera up than this
  if((buttonPinTiltCameraUpVal==LOW) && (buttonPinTiltCameraDownVal==HIGH) && (cameraYPosition < maximumCameraUpPosition))     {

    cameraYPosition++;

//    Serial.print("[Tilt Up pressed] Y Calculate cameraYPosition\t=");
//    Serial.print(cameraYPosition);
//    Serial.print("\tLeft Right cameraXPosition\t=");
//    Serial.print(cameraXPosition);
  }   // Y Tilt Up Calculate

  // Y Tilt Down Calculate
  // No more panning camera up than this
  if((buttonPinTiltCameraDownVal==LOW) && (buttonPinTiltCameraUpVal==HIGH) && (cameraYPosition > maximumCameraDownPosition))     {

    cameraYPosition--;

//    Serial.print("[Tilt Down pressed] Y Calculate cameraYPosition\t=");
//    Serial.print(cameraYPosition);
//    Serial.print("\tLeft Right cameraXPosition\t=");
//    Serial.print(cameraXPosition);
  }   // Y Tilt down Calculate


  // X Pan Camera actual move

  stepper1.moveTo(cameraXPosition); 

  // Tell the stepper to move to
  // requested position
  stepper1.run();

  // Y Tilt Camera actual move

  stepper2.moveTo(cameraYPosition); 

  // Tell the stepper to move to
  // requested position
  stepper2.run();


  // Speed button pressed
  if (buttonPinFasterSpeedVal==LOW) {
//    Serial.print("Speed button is pressed expect LOW=\t");
//    Serial.println(buttonPinFasterSpeedVal);
//    Serial.println();    

    // Move quicker, less delay
    delay (5);
  }
  else  {
//    Serial.print("Speed button NOT pressed expect HIGH=\t");
//    Serial.println(buttonPinFasterSpeedVal);
//    Serial.println();
    
    // Move slower, more delay
    // The is the normal speed button not pressed
    delay (25);
  }
}  // loop




/////////////////////////////////////
////////////////////////////////////

/*
 Unused code that could be useful untested
 
   // Stop as fast as possible: sets new target
  stepper1.stop();
  stepper1.runToPosition(); 

 while(!stepper1.distanceToGo()) { }

  // Stop as fast as possible: sets new target
 stepper2.stop();
 stepper2.runToPosition(); 

while(!stepper2.distanceToGo()) { }



 // Stop by the sketch ruuning, loopping forevever
 // Not a true stop
 while( 1 ) {  }

 Unused code that could be useful untested 
*/

